package com.unipi.talepis;

import java.util.Scanner;

public class DemoThread1 {
    public static void main(String[] args) {
        MyThread t1 = new MyThread();
        t1.setDaemon(true);
        t1.start();
        Scanner scanner = new Scanner(System.in);
        while (true){
            System.out.println("Give a command:");
            String command = scanner.nextLine();
            if (command.equals("exit"))
                return;
            else if (command.contains("new")){
                String message = command.replace("new ","");
                t1.setMessage(message);
                for (int i = 0; i<20;i++){
                    int finalI = i;
                    new Thread(()->t1.setMessage("Peter"+String.valueOf(finalI))).start();
                }

            } else {
                System.out.println("Unsupported command");
            }
        }
    }
}

class MyThread extends Thread{
    private String message;

    public synchronized void setMessage(String message) {
        this.message = message;
        this.interrupt();
    }

    @Override
    public void run() {
        while (true){
            if (message!=null){
                if (message.equals("exit")){
                    System.out.println("Thread is exiting");
                    return;
                }
                processMessages(message);
                message = null;
            }
            try {
                Thread.sleep(60000);
            } catch (InterruptedException e) {
                if (e instanceof InterruptedException){
                    continue;
                }
                e.printStackTrace();
            }
        }
    }
    private void processMessages(String message){
        System.out.println("I am doing something with:"+message);
    }
}
